' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -------------------------------------------------------------------
' FVX Sample Program
' 2lvʕ\tH[
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/14 
'
' -------------------------------------------------------------------

Imports Microsoft
Imports FVDATASLib

Public Class frmBlobResult

    Private Const PI As Double = 3.14159265358979

    'SBlob
    Public intMaxBlobNum As Integer

    'ݕ\ĂBlobNo
    Private m_intBlobNo As Integer

    Private Sub frmBlobResult_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim i As Integer
        Dim intArea As Integer
        Dim intMaxArea As Integer
        Dim intMaxAreaIndex As Integer

        'őʐς̃u[uT
        intMaxArea = -1
        intMaxAreaIndex = -1
        For i = 0 To intMaxBlobNum - 1
            intArea = frmMain.AxFvxBlob1.GetResultArea(i)
            If intMaxArea < intArea Then
                intMaxArea = intArea
                intMaxAreaIndex = i
            End If
        Next i

        If -1 <> intMaxAreaIndex Then
            'őʐς̏\
            m_intBlobNo = frmMain.AxFvxBlob1.GetBlobNo(intMaxAreaIndex)
            DrawOneFromBlobNo(m_intBlobNo)
        End If

    End Sub

    'I
    Private Sub btnExitForm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExitForm.Click

        Me.Close()

    End Sub

    'eBlob
    Private Sub btnParentBlob_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnParentBlob.Click

        Dim intParentBlobNo As Integer
        Dim pBlobResult As New FvBlobResult

        intParentBlobNo = frmMain.AxFvxBlob1.GetParentFromBlobNo(m_intBlobNo)
        If -1 <> intParentBlobNo Then
            DrawOneFromBlobNo(intParentBlobNo)
            m_intBlobNo = intParentBlobNo
        End If

    End Sub

    'qBlob
    Private Sub btnChildBlob_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChildBlob.Click

        Dim intChildBlobNo As Integer
        Dim pBlobResult As New FvBlobResult

        intChildBlobNo = frmMain.AxFvxBlob1.GetChildFromBlobNo(m_intBlobNo)
        If -1 <> intChildBlobNo Then
            DrawOneFromBlobNo(intChildBlobNo)
            m_intBlobNo = intChildBlobNo
        End If

    End Sub

    'ZBlob
    Private Sub btnSiblingBlob_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSiblingBlob.Click

        Dim intSiblingBlobNo As Integer
        Dim pBlobResult As New FvBlobResult

        intSiblingBlobNo = frmMain.AxFvxBlob1.GetSiblingFromBlobNo(m_intBlobNo)
        If -1 <> intSiblingBlobNo Then
            DrawOneFromBlobNo(intSiblingBlobNo)
            m_intBlobNo = intSiblingBlobNo
        End If

    End Sub

    'Periphry
    Private Sub btnPeriphry_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPeriphry.Click

        Dim pPointGroup As New FvPointGroup
        Dim pPoint As New FvPoint
        Dim Str As String = ""
        Dim i As Integer

        Try
            frmMain.AxFvxBlob1.GetResultPeriphryFromBlobNo(frmMain.AxFvxImageBin.GetOcx(), m_intBlobNo, pPointGroup, FVXCOMBLOBLib.BLOB_VECTOR_TYPE.BLOB_VECTOR_OFF)
            For i = 0 To pPointGroup.Count() - 1
                pPoint = pPointGroup.Item2(i)
                Str = Str + _
                    "[" + i.ToString() + "] " + "(x,y) = " + VisualBasic.Format(pPoint.x, "0.0") + ", " + VisualBasic.Format(pPoint.y, "0.0") + ")" + vbCrLf
            Next i
            Str = Str + vbCrLf

            txtResult.Text = txtResult.Text + Str

            frmMain.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(&HFF, 0, 0)
            frmMain.AxFvxDisplayEx1.DrawData(1, pPointGroup)
            frmMain.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, &HFF)
        Catch ex As Exception
            Dim intErr As Integer
            frmMain.AxFvxBlob1.GetErrReport(intErr)
            MsgBox("Periphry : ͒̌vłȂu[uł : ErrorCode=" + intErr.ToString(), vbOKOnly, "Error")
        End Try

    End Sub

    'Blob Paint
    Private Sub btnBlobPaint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBlobPaint.Click

        Dim pBlobResult As New FvBlobResult

        Try
            'u[uڍ׏擾
            frmMain.AxFvxBlob1.GetResultFromBlobNo(m_intBlobNo, pBlobResult)

            If pBlobResult.color = 0 Then
                'u[uȂAœh
                frmMain.AxFvxBlob1.BlobPaintFromBlobNo(frmMain.AxFvxImageBin.GetOcx(), m_intBlobNo, FVXCOMBLOBLib.COLOR_TYPE.WHITE_COLOR)
            Else
                frmMain.AxFvxBlob1.BlobPaintFromBlobNo(frmMain.AxFvxImageBin.GetOcx(), m_intBlobNo, FVXCOMBLOBLib.COLOR_TYPE.BLACK_COLOR)
            End If

            'ĕ`
            frmMain.AxFvxDisplayEx1.DrawImage(frmMain.AxFvxImageBin.GetOcx())
        Catch ex As Exception
            Dim intErr As Long
            frmMain.AxFvxBlob1.GetErrReport(intErr)
            MsgBox("ErrorCode=" + intErr.ToString() + ", " + Err.Description, vbOKOnly, "Error")
        End Try

    End Sub

    '1Blob`
    Private Sub DrawOneFromBlobNo(ByVal intBlobNo As Integer)

        Dim pBlobResult As New FvBlobResult
        Dim dblAngle As Double 'ȉ~XΊpixj
        Dim pLine As New FvLine
        Dim pEllipse As New FvEllipse

        txtBlobNo.Text = intBlobNo.ToString()

        With frmMain
            'I[o[Cʂ̏
            .AxFvxDisplayEx1.ClearOverlay()

            '͈͂𔖐ŕ\
            .AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(192, 192, 255)
            .AxFvxDisplayEx1.DrawData(0, .m_ExeRegion)

            'u[uڍ׏擾
            .AxFvxBlob1.GetResultFromBlobNo(intBlobNo, pBlobResult)
        End With

        'u[ȕڍׂȏeLXg{bNXɕ\
        txtResult.Text = _
            "u[uԍ : " & VisualBasic.Format(pBlobResult.blob_no, "0") & vbCrLf & _
            "܂܂Ȃʐ : " & VisualBasic.Format(pBlobResult.area, "0.00") & vbCrLf & _
            " : " & VisualBasic.Format(pBlobResult.hole_num, "0.00") & vbCrLf & _
            "͒ : " & VisualBasic.Format(pBlobResult.perim, "0.00") & vbCrLf & _
            "ȉ~厲 : " & VisualBasic.Format(pBlobResult.ellipse_long, "0.00") & vbCrLf & _
            "ȉ~ : " & VisualBasic.Format(pBlobResult.ellipse_short, "0.00") & vbCrLf & _
            "ȉ~XΊp : " & VisualBasic.Format(pBlobResult.ellipse_angle, "0.00") & vbCrLf & _
            "dSW : ( " & VisualBasic.Format(pBlobResult.center_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.center_y, "0.00") & " )" & vbCrLf & _
            "Xŏl : " & VisualBasic.Format(pBlobResult.x_min, "0.00") & vbCrLf & _
            "Xől : " & VisualBasic.Format(pBlobResult.x_max, "0.00") & vbCrLf & _
            "Yŏl : " & VisualBasic.Format(pBlobResult.y_min, "0.00") & vbCrLf & _
            "Yől : " & VisualBasic.Format(pBlobResult.y_max, "0.00") & vbCrLf & _
            "܂߂ʐ : " & VisualBasic.Format(pBlobResult.total_area, "0.00") & vbCrLf & _
            "Oڒ`  : ( " & VisualBasic.Format(pBlobResult.bounding_top_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_top_y, "0.00") & " )" & vbCrLf & _
            "Oڒ` E : ( " & VisualBasic.Format(pBlobResult.bounding_right_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_right_y, "0.00") & " )" & vbCrLf & _
            "Oڒ`  : ( " & VisualBasic.Format(pBlobResult.bounding_left_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_left_y, "0.00") & " )" & vbCrLf & _
            "Oڒ` E : ( " & VisualBasic.Format(pBlobResult.bounding_bottom_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_bottom_y, "0.00") & " )" & vbCrLf
        txtResult.Text = txtResult.Text + _
            " : " & VisualBasic.Format(pBlobResult.hole_num, "0.00") & vbCrLf & _
            " : " & VisualBasic.Format(pBlobResult.hole_dist_ave, "0.00") & vbCrLf & _
            "ŏ : " & VisualBasic.Format(pBlobResult.hole_dist_min, "0.00") & vbCrLf & _
            "ő : " & VisualBasic.Format(pBlobResult.hole_dist_max, "0.00") & vbCrLf & _
            "אڃu[u : " & VisualBasic.Format(pBlobResult.hole_dist_max, "0.00") & vbCrLf & _
            "אڃu[u : " & VisualBasic.Format(pBlobResult.sdist_ave, "0.00") & vbCrLf & _
            "אڃu[uŏ : " & VisualBasic.Format(pBlobResult.sdist_min, "0.00") & vbCrLf & _
            "אڃu[uő : " & VisualBasic.Format(pBlobResult.sdist_max, "0.00") & vbCrLf & vbCrLf

        'F = 
        frmMain.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

        'ȉ~
        pEllipse.angle = pBlobResult.ellipse_angle
        pEllipse.axis_x = pBlobResult.ellipse_long
        pEllipse.axis_y = pBlobResult.ellipse_short
        pEllipse.x = pBlobResult.center_x
        pEllipse.y = pBlobResult.center_y
        frmMain.AxFvxDisplayEx1.DrawData(0, pEllipse)

        'dSʂAȉ~̒yђZ̒
        ' dS_: ( x1, y1 )    ȉ~XΊp: ƂƁA̎
        ' - xsin + ycos + ( x1sin - y1cos ) = 0
        dblAngle = pBlobResult.ellipse_angle * PI / 180
        pLine.a = -System.Math.Sin(dblAngle)
        pLine.b = System.Math.Cos(dblAngle)
        pLine.c = (pBlobResult.center_x * System.Math.Sin(dblAngle)) - (pBlobResult.center_y * System.Math.Cos(dblAngle))
        frmMain.AxFvxDisplayEx1.DrawData(0, pLine)

        dblAngle = (pBlobResult.ellipse_angle + 90) * PI / 180
        pLine.a = -System.Math.Sin(dblAngle)
        pLine.b = System.Math.Cos(dblAngle)
        pLine.c = (pBlobResult.center_x * System.Math.Sin(dblAngle)) - (pBlobResult.center_y * System.Math.Cos(dblAngle))
        frmMain.AxFvxDisplayEx1.DrawData(0, pLine)

        'dS_ƊOڒ`̕`
        frmMain.AxFvxDisplayEx1.DrawData(0, pBlobResult)

    End Sub

End Class